# coding: utf-8
'''
'''
import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from common.htmlhints.htmlHint import htmlHintElement
from gridsettings.functions.gridSettings import toolbar_button_panel
from medstaff._medstaff_orm import student_eor_tasksCursor

def datapanel(context, main=None, session=None):
    data = {'datapanel': {'tab': []}}

    tab1 = {'@id': 1,
            '@name': u'Мои программы',
            'element': []}

    student_program_grid = {
        "@id": 'studentProgramGrid',
        "@type":"grid",
        "@subtype":"JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc":"medstaff.grid.studentProgramGrid.gridData.celesta",
        "@hideOnLoad":'false',
        "proc": [                     
            {"@id":'studentCycleGridMeta',
             "@name":'medstaff.grid.studentProgramGrid.gridMeta.celesta',
             "@type": 'METADATA'},
            {"@id": "proc2",
             "@name":"medstaff.grid.studentProgramGrid.gridToolBar.celesta",
             "@type": "TOOLBAR"}]}

    courseInfoCard = {
        '@id': 'courseCardInfo',
        '@type': 'xforms',
        '@proc': 'medstaff.xform.courseInfoCard.infoCardData.celesta',
        '@template': 'edu/courseCardInfo.xml',
        '@hideOnLoad': 'true',
        'related': {
            '@id': 'studentProgramGrid'}}

    eduOrgInfoCard = {
        '@id': 'eduOrgInfoCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.eduOrganizationCard.cardData.celesta',
        '@template':'nci/eduOrganizationInfoCard.xml',
        '@hideOnLoad':'true',
        "related":
           [{"@id":'studentProgramGrid'}]}

#     tab1['element'].append(dpppkCyclesFilter)
    tab1['element'].append(htmlHintElement('medstaff_certificates'))
    tab1['element'].append(student_program_grid)
    tab1['element'].append(courseInfoCard)
    tab1['element'].append(eduOrgInfoCard)
    tab1['element'].append(toolbar_button_panel())
    data['datapanel']['tab'].extend([tab1])

    return XMLJSONConverter.jsonToXml(json.dumps(data))

def datapanelCompleted(context, main=None, session=None):
    data = {'datapanel': {'tab': []}}

    tab1 = {'@id': 1,
            '@name': u'Завершённые программы',
            'element': []}

    student_program_grid = {
        "@id": 'studentProgramGrid',
        "@type":"grid",
        "@subtype":"JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc":"medstaff.grid.studentProgramGrid.gridData.celesta",
        "@hideOnLoad":'false',
        "proc": [                     
            {"@id":'studentCycleGridMeta',
             "@name":'medstaff.grid.studentProgramGrid.gridMeta.celesta',
             "@type": 'METADATA'},
            {"@id": "proc2",
             "@name":"medstaff.grid.studentProgramGrid.gridToolBar.celesta",
             "@type": "TOOLBAR"}]}
    
    downloadCertificateCard = {
        '@id': 'downloadCertificateFromCertCard',
        '@type': 'xforms',
        '@proc': 'medstaff.xform.downloadCertificateCard.cardData.celesta',
        '@template': 'downloadCertificateCard.xml',
        '@hideOnLoad': 'true',
        'proc': {
            '@id': 'save',
            '@name': 'medstaff.xform.downloadCertificateCard.cardDataSave.celesta',
            '@type': 'SAVE'},
        'related': {
            '@id': 'studentProgramGrid'}}

    courseInfoCard = {
        '@id': 'courseCardInfo',
        '@type': 'xforms',
        '@proc': 'medstaff.xform.courseInfoCard.infoCardData.celesta',
        '@template': 'edu/courseCardInfo.xml',
        '@hideOnLoad': 'true',
        'related': {
            '@id': 'studentProgramGrid'}}

    eduOrgInfoCard = {
        '@id': 'eduOrgInfoCard',
        '@type': 'xforms',
        '@proc': 'nci.xform.eduOrganizationCard.cardData.celesta',
        '@template':'nci/eduOrganizationInfoCard.xml',
        '@hideOnLoad':'true',
        "related":
           [{"@id":'studentProgramGrid'}]}

#     tab1['element'].append(dpppkCyclesFilter)
    tab1['element'].append(htmlHintElement('medstaff_certificates'))
    tab1['element'].append(student_program_grid)
    tab1['element'].append(courseInfoCard)
    tab1['element'].append(eduOrgInfoCard)
    tab1['element'].append(downloadCertificateCard)
    tab1['element'].append(toolbar_button_panel())
    data['datapanel']['tab'].extend([tab1])

    return XMLJSONConverter.jsonToXml(json.dumps(data))


def datapanelProgram(context, main=None, session=None):
    data = {'datapanel': {'tab': []}}
    
    tab0 = {
        '@id': 1,
        '@name': u'Информация по программе',
        'element': []
    }
    
#     courseCardInfo = {
#         '@id': 'courseCardInfo',
#         '@type': 'xforms',
#         '@proc': 'edu.xform.courseCard.cardData.celesta',
#         '@template': 'edu/courseCardInfo.xml'}
    
    courseCardInfo = {
        '@id': 'courseCardInfo',
        '@type': 'xforms',
        '@proc': 'medstaff.xform.courseInfoCard.noteCardData.celesta',
        '@template': 'courseNoteCard.xml'}
    
    tab0['element'].append(courseCardInfo)    
    data['datapanel']['tab'].extend([tab0])

    tab1 = {'@id': 'program',
            '@name': u'Темы по программе',
            'element': []}
    
    student_cycle_grid = {
        "@id": 'studentCycleGrid',
        "@type":"grid",
        "@subtype":"JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc":"medstaff.grid.studentCycleGrid.gridData.celesta",
        "@hideOnLoad":'false',
        "proc": [                     
            {"@id":'studentCycleGridMeta',
             "@name":'medstaff.grid.studentCycleGrid.gridMeta.celesta',
             "@type": 'METADATA'},
            {"@id": "proc2",
             "@name":"medstaff.grid.studentCycleGrid.gridToolBar.celesta",
             "@type": "TOOLBAR"}]}
    
    tab1['element'].append(student_cycle_grid)
    data['datapanel']['tab'].extend([tab1])
    
    return XMLJSONConverter.jsonToXml(json.dumps(data))
    

def datapanelCycle(context, main=None, session=None):
    data = {'datapanel': {'tab': []}}
    
    tab0 = {'@id': 'studentTasks',
            '@name': u'Учебный план по теме',
            'element': []}
    
    main_jsn = json.loads(main)
    cycle_id = main_jsn['cycle_id']
    certificate = main_jsn['certificate']
    
    taskCur = student_eor_tasksCursor(context)
    taskCur.setRange('student_certificate', certificate)
    taskCur.setRange('cycle_id', cycle_id)
    taskCur.orderBy('qti_order')
    for task in taskCur.iterate():
        taskCard = {
        '@id': 'task-{}'.format(task.task_id),
        '@type': 'xforms',
        '@proc': 'medstaff.xform.studentTaskCard.taskData.celesta',
        '@template': 'studentTaskCard.xml',
        'proc': [ 
            {'@id': 'taskCard_{}_save'.format(task.qti_order),
             '@name': 'medstaff.xform.studentTaskCard.taskSave.celesta',
             '@type': 'SAVE'},
            {"@id": 'uploadFile',
             "@name": "medstaff.xform.studentTaskCard.uploadTaskFile.cl",
             "@type": "UPLOAD"},]}
        
        tab0['element'].append(taskCard)
        
    taskCur.close()    
    
    data['datapanel']['tab'].extend([tab0])
   
    return XMLJSONConverter.jsonToXml(json.dumps(data))


def datapanelRequests(context, main=None, session=None):
    data = {"datapanel": {"tab": []}}
    
    tab1 = {
        "@id": 1,
        "@name": u"Заявки на программы",
        "element": []}

#     certificateFilter = {
#         "@id": "certificateFilter",
#         "@type": "xforms",
#         "@proc": "edu.xform.certificateFilter.cardData.celesta",
#         "@template": "certificateFilter.xml",
#         "@hideOnLoad": "true",
#         'proc': {
#             '@id': 'proc',
#             '@name': 'edu.xform.certificateFilter.cardDataSave.celesta',
#             '@type': 'SAVE'}}

    accredCycleRequestsGrid = {
        "@id": "certificationRequestGrid",
        "@type": "grid",
        "@subtype": "JS_PAGE_GRID",
        "@plugin": "pageDGrid",
        "@proc":"medstaff.grid.certificationGrid.gridData.celesta",
        "@hideOnLoad": "false",
        "proc": [
            {"@id": "proc1",
             "@name":'medstaff.grid.certificationGrid.gridMeta.celesta',
             "@type": "METADATA"},
            {"@id": "proc2",
             "@name":"medstaff.grid.certificationGrid.gridToolBar.celesta",
             "@type": "TOOLBAR"}]}
    
    courseInfoCard = {
        '@id': 'courseCard',
        '@type': 'xforms',
        '@proc': 'edu.xform.courseCard.cardData.celesta',
        '@template': 'edu/courseCard.xml',
        '@hideOnLoad': 'true',
        'related': {
            '@id': 'certificationRequestGrid'
        }
    }
    
    cancelRequestCard = {
        '@id': 'cancelRequestCard',
        '@type': 'xforms',
        '@proc': 'medstaff.xform.downloadCertificateCard.cancelRequestData.celesta',
        '@template': 'delElementStandardCard.xml',
        '@neverShowInPanel': 'true',
        'proc': {
            '@id': 'save',
            '@name': 'medstaff.xform.downloadCertificateCard.cancelRequestSave.celesta',
            '@type': 'SAVE'},
        "related": [
            {"@id":'certificationRequestGrid'}]}


    tab1['element'].append(htmlHintElement('certificateRequest'))
    tab1['element'].append(toolbar_button_panel())
#     tab1["element"].append(certificateFilter)
    tab1["element"].append(accredCycleRequestsGrid)
    tab1['element'].append(courseInfoCard)
    tab1['element'].append(cancelRequestCard)
    data["datapanel"]["tab"].extend([tab1])

    return XMLJSONConverter.jsonToXml(json.dumps(data))
